

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.49. reference_acquire &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.50. reference_release" href="reference_release.html" />
    <link rel="prev" title="7.3.48. range_filter" href="range_filter.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/reference_acquire.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="reference_release.html" title="7.3.50. reference_release"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="range_filter.html" title="7.3.48. range_filter"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.49. </span><code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="reference-acquire">
<h1><span class="section-number">7.3.49. </span><code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code><a class="headerlink" href="#reference-acquire" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.49.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 10.0.4.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code> acquires a reference of target objects.</p>
<p>This command is meaningless unless you use the reference count
mode. You can enable the reference count mode by the
<code class="docutils literal notranslate"><span class="pre">GRN_ENABLE_REFERENCE_COUNT=yes</span></code> environment variable.</p>
<p>If you acquires a reference of an object, the object isn’t closed
automatically because you have at least one reference of the
object. If you need to call multiple <a class="reference internal" href="load.html"><span class="doc">load</span></a> in a short time, auto
close by the reference count mode will degrade performance. You can
avoid the performance degrading by calling <code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code>
before multiple <a class="reference internal" href="load.html"><span class="doc">load</span></a> and calling <a class="reference internal" href="reference_release.html"><span class="doc">reference_release</span></a> after
multiple <a class="reference internal" href="load.html"><span class="doc">load</span></a>. Between <code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code> and
<a class="reference internal" href="reference_release.html"><span class="doc">reference_release</span></a>, auto close is disabled.</p>
<p>You must call <a class="reference internal" href="reference_release.html"><span class="doc">reference_release</span></a> after you finish performance
impact operations. If you don’t call <a class="reference internal" href="reference_release.html"><span class="doc">reference_release</span></a>, the
reference count mode doesn’t work.</p>
<p>You can use <a class="reference internal" href="#reference-acquire-auto-release-count"><span class="std std-ref">auto_release_count</span></a> instead of
calling <a class="reference internal" href="reference_release.html"><span class="doc">reference_release</span></a>. You can release acquired references
automatically by <a class="reference internal" href="#reference-acquire-auto-release-count"><span class="std std-ref">auto_release_count</span></a>. But you
need to tune suitable <a class="reference internal" href="#reference-acquire-auto-release-count"><span class="std std-ref">auto_release_count</span></a>
value. If you specify too large number, auto close isn’t triggered. If
you specify too small number, auto close is triggered before
performance impact operations are finished.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.49.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This command takes two parameters.</p>
<p>All parameters are optional:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire [target_name=null]
                  [recursive=yes]
                  [auto_release_count=0]
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.49.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>You can acquire a reference of the all objects with no arguments:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you know what should be referred, you can narrow targets.</p>
<p>Here is a schema definition to show usage:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Users TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Users age COLUMN_SCALAR UInt8
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Users introduction COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Ages TABLE_PAT_KEY UInt8
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Ages user_age COLUMN_INDEX Users age
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you want to call multiple <a class="reference internal" href="select.html"><span class="doc">select</span></a> without any condition
against <code class="docutils literal notranslate"><span class="pre">Users</span></code> table, the following command acquires a reference of
<code class="docutils literal notranslate"><span class="pre">Users</span></code>, <code class="docutils literal notranslate"><span class="pre">Users.age</span></code> and <code class="docutils literal notranslate"><span class="pre">Users.introduction</span></code>:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you want to call multiple <a class="reference internal" href="select.html"><span class="doc">select</span></a> with condition that uses
indexes against <code class="docutils literal notranslate"><span class="pre">Users</span></code> table, the following command acquires a
reference of <code class="docutils literal notranslate"><span class="pre">Users</span></code>, <code class="docutils literal notranslate"><span class="pre">Users.age</span></code>, <code class="docutils literal notranslate"><span class="pre">Users.introduction</span></code>,
<code class="docutils literal notranslate"><span class="pre">Ages</span></code> (lexicon) and <code class="docutils literal notranslate"><span class="pre">Ages.user_age</span></code> (index column). This command
is suitable for <a class="reference internal" href="load.html"><span class="doc">load</span></a> too:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users --recursive dependent
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you want to just refer <code class="docutils literal notranslate"><span class="pre">Users</span></code>, you can specify a table with
<code class="docutils literal notranslate"><span class="pre">recursive=no</span></code>:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users --recursive no
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you want to just refer <code class="docutils literal notranslate"><span class="pre">Users.introduction</span></code>, you can specify a
column:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users.introduction
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>You can release acquired references by calling
<a class="reference internal" href="reference_release.html"><span class="doc">reference_release</span></a> with the same arguments:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users --recursive dependent
# [[0, 1337566253.89858, 0.000355720520019531], true]
# select Users ...
# load --table Users ...
reference_release --target_name Users --recursive dependent
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.49.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes all parameters.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.49.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is no required parameter.</p>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.49.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p>There are optional parameters.</p>
<div class="section" id="target-name">
<span id="reference-acquire-target-name"></span><h4><span class="section-number">7.3.49.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">target_name</span></code><a class="headerlink" href="#target-name" title="Permalink to this headline">¶</a></h4>
<p>Specifies a target object name. Target object is one of database,
table or column.</p>
<p>If you omit this parameter, database is the target object:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you specify a table name, the table is the target object:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you specify a column name, the column is the target object:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users.age
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
</div>
<div class="section" id="recursive">
<span id="reference-acquire-recursive"></span><h4><span class="section-number">7.3.49.4.2.2. </span><code class="docutils literal notranslate"><span class="pre">recursive</span></code><a class="headerlink" href="#recursive" title="Permalink to this headline">¶</a></h4>
<p>Specifies whether child objects of the target object are also target
objects.</p>
<p>Child objects of database are all tables and all columns.</p>
<p>Child objects of table are all its columns.</p>
<p>Child objects of column are nothing.</p>
<p><code class="docutils literal notranslate"><span class="pre">recursive</span></code> value must be <code class="docutils literal notranslate"><span class="pre">yes</span></code>, <code class="docutils literal notranslate"><span class="pre">no</span></code> or <code class="docutils literal notranslate"><span class="pre">dependent</span></code>. <code class="docutils literal notranslate"><span class="pre">yes</span></code>
means that all of the specified target object and child objects are
the target objects. <code class="docutils literal notranslate"><span class="pre">no</span></code> means that only the specified target object
is the target object. <code class="docutils literal notranslate"><span class="pre">dependent</span></code> means that all of the specified
target object, child objects, corresponding table of index column and
corresponding index column are the target objects.</p>
<p>The following <code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code> acquires a reference of all tables
and all columns:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --recursive yes
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>The following <code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code> acquires a reference of only
<code class="docutils literal notranslate"><span class="pre">Users</span></code> table:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users --recursive no
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>If you specify other value (not <code class="docutils literal notranslate"><span class="pre">yes</span></code> neither <code class="docutils literal notranslate"><span class="pre">no</span></code>) or omit
<code class="docutils literal notranslate"><span class="pre">recursive</span></code> parameter, <code class="docutils literal notranslate"><span class="pre">yes</span></code> is used.</p>
<p><code class="docutils literal notranslate"><span class="pre">yes</span></code> is used in the following case because invalid <code class="docutils literal notranslate"><span class="pre">recursive</span></code>
argument is specified:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users --recursive invalid
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">yes</span></code> is used in the following case because <code class="docutils literal notranslate"><span class="pre">recursive</span></code> parameter
isn’t specified:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">dependent</span></code> acquires a reference of not only the target object and
the child objects but also related objects. The related objects are:</p>
<ul class="simple">
<li><p>A referenced table</p></li>
<li><p>Data columns of referenced tables</p></li>
<li><p>A related index column (There is source column in target <code class="docutils literal notranslate"><span class="pre">TABLE_NAME</span></code>)</p></li>
<li><p>A table of related index column (There is source column in target <code class="docutils literal notranslate"><span class="pre">TABLE_NAME</span></code>)</p></li>
<li><p>Data columns of tables of related index columns</p></li>
</ul>
<p>It is useful to keep reference for <a class="reference internal" href="load.html"><span class="doc">load</span></a> and <a class="reference internal" href="select.html"><span class="doc">select</span></a>.</p>
<p>If you want to call multiple <a class="reference internal" href="load.html"><span class="doc">load</span></a> for <code class="docutils literal notranslate"><span class="pre">Users</span></code> table, you can
use the following command:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users --recursive dependent
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
</div>
<div class="section" id="auto-release-count">
<span id="reference-acquire-auto-release-count"></span><h4><span class="section-number">7.3.49.4.2.3. </span><code class="docutils literal notranslate"><span class="pre">auto_release_count</span></code><a class="headerlink" href="#auto-release-count" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">New in version 10.0.9.</span></p>
</div>
<p>You can release acquired references automatically by
<code class="docutils literal notranslate"><span class="pre">auto_release_count</span></code>.</p>
<p>If <code class="docutils literal notranslate"><span class="pre">auto_release_count</span></code> is 1 or greater, acquired references are
automatically after the following <code class="docutils literal notranslate"><span class="pre">auto_release_count</span></code> commands are
processed. You must not call corresponding <a class="reference internal" href="reference_release.html"><span class="doc">reference_release</span></a>
when you use <code class="docutils literal notranslate"><span class="pre">auto_release_count</span></code>.</p>
<p>In the following example, the acquired reference of <code class="docutils literal notranslate"><span class="pre">Users</span></code> is
released automatically after the second <code class="docutils literal notranslate"><span class="pre">status</span></code> is processed:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reference_acquire --target_name Users --auto_release_count 2
status # Users is still referred.
status # Users&#39; reference is released after this command is processed.
</pre></div>
</div>
<p>The same <a class="reference internal" href="#reference-acquire-recursive"><span class="std std-ref">recursive</span></a> is used when acquired
references are released automatically. You don’t need to care about
<a class="reference internal" href="#reference-acquire-recursive"><span class="std std-ref">recursive</span></a>.</p>
<p><code class="docutils literal notranslate"><span class="pre">auto_release_count</span></code> is safe with <a class="reference internal" href="table_remove.html"><span class="doc">table_remove</span></a>,
<a class="reference internal" href="column_remove.html"><span class="doc">column_remove</span></a> and <a class="reference internal" href="database_unmap.html"><span class="doc">database_unmap</span></a>. If one of them are
called, registered auto release hook is removed internally.</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.49.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p>The command returns <code class="docutils literal notranslate"><span class="pre">true</span></code> as body on success such as:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, true]
</pre></div>
</div>
<p>If the command fails, error details are in <code class="docutils literal notranslate"><span class="pre">HEADER</span></code>.</p>
<p>See <a class="reference internal" href="../command/output_format.html"><span class="doc">Output format</span></a> for <code class="docutils literal notranslate"><span class="pre">HEADER</span></code>.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.49. <code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.49.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.49.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.49.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.49.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.49.4.1. Required parameters</a></li>
<li><a class="reference internal" href="#optional-parameters">7.3.49.4.2. Optional parameters</a><ul>
<li><a class="reference internal" href="#target-name">7.3.49.4.2.1. <code class="docutils literal notranslate"><span class="pre">target_name</span></code></a></li>
<li><a class="reference internal" href="#recursive">7.3.49.4.2.2. <code class="docutils literal notranslate"><span class="pre">recursive</span></code></a></li>
<li><a class="reference internal" href="#auto-release-count">7.3.49.4.2.3. <code class="docutils literal notranslate"><span class="pre">auto_release_count</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.49.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="range_filter.html"
                        title="previous chapter"><span class="section-number">7.3.48. </span><code class="docutils literal notranslate"><span class="pre">range_filter</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="reference_release.html"
                        title="next chapter"><span class="section-number">7.3.50. </span><code class="docutils literal notranslate"><span class="pre">reference_release</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="reference_release.html" title="7.3.50. reference_release"
             >next</a> |</li>
        <li class="right" >
          <a href="range_filter.html" title="7.3.48. range_filter"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.49. </span><code class="docutils literal notranslate"><span class="pre">reference_acquire</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>